package com.studioirregular.tatala.check;

import java.util.ArrayList;
import java.util.List;

import com.studioirregular.tatala.BaseActivity;
import com.studioirregular.tatala.Engine;
import com.studioirregular.tatala.Engine.EngineParams;
import com.studioirregular.tatala.component.FrameAnimation;
import com.studioirregular.tatala.entity.Entity;
import com.studioirregular.tatala.entity.Scene;
import com.studioirregular.tatala.opengl.TextureSystem;
import com.studioirregular.tatala.opengl.TextureSystem.CreateRegion;
import com.studioirregular.tatala.opengl.TextureSystem.CreateTexture;

public class DemoAnimation extends BaseActivity {

    @Override
    protected EngineParams obtainEngineParams() {
        return new Engine.EngineParams(720, 480);
    }
    
    @Override
    protected void onLoadResource() {
        List<CreateRegion> regionList = new ArrayList<CreateRegion>();
        
        regionList.add(new CreateRegion("background", 0, 0, 720, 450));
        regionList.add(new CreateRegion("spark_1", 0, 450, 315, 267));
        regionList.add(new CreateRegion("spark_2", 315, 450, 315, 267));
        regionList.add(new CreateRegion("spark_3", 630, 450, 315, 267));
        regionList.add(new CreateRegion("spark_4", 0, 717, 315, 267));
        regionList.add(new CreateRegion("spark_5", 0, 717, 315, 267));
        regionList.add(new CreateRegion("spark_6", 0, 717, 315, 267));
        
        TextureSystem.getInstance().add(new CreateTexture("texture_1", R.drawable.texture_1), regionList);
    }
    
    @Override
    protected Scene onBuildScene() {
        Scene scene = new Scene("scene", 720, 480, "texture_1", "background");
        
        Entity sparkle = new Entity("animation", 196, 0, 315, 267);
        FrameAnimation animation = new FrameAnimation("animation-sparkle", 315, 267, 6, true);
        animation.addFrame("texture_1", "spark_1", 100);
        animation.addFrame("texture_1", "spark_2", 100);
        animation.addFrame("texture_1", "spark_3", 100);
        animation.addFrame("texture_1", "spark_4", 100);
        animation.addFrame("texture_1", "spark_5", 100);
        animation.addFrame("texture_1", "spark_6", 100);
        animation.start();
        sparkle.add(animation);
        
        scene.add(sparkle);
        
        return scene;
    }

}
