package com.studioirregular.tatala.check;

import java.util.ArrayList;
import java.util.List;

import com.studioirregular.tatala.BaseActivity;
import com.studioirregular.tatala.Engine;
import com.studioirregular.tatala.Engine.EngineParams;
import com.studioirregular.tatala.component.ButtonComponent;
import com.studioirregular.tatala.component.DraggableComponent;
import com.studioirregular.tatala.component.RenderComponent;
import com.studioirregular.tatala.component.ToggleButton;
import com.studioirregular.tatala.entity.Entity;
import com.studioirregular.tatala.entity.Scene;
import com.studioirregular.tatala.opengl.TextureSystem;
import com.studioirregular.tatala.opengl.TextureSystem.CreateRegion;
import com.studioirregular.tatala.opengl.TextureSystem.CreateTexture;

public class DemoButton extends BaseActivity {

    @Override
    protected EngineParams obtainEngineParams() {
        return new Engine.EngineParams(720, 480);
    }

    @Override
    protected void onLoadResource() {
        List<CreateRegion> regionList = new ArrayList<CreateRegion>();
        
        regionList.add(new CreateRegion("background", 0, 0, 720, 450));
        regionList.add(new CreateRegion("button_up", 720, 0, 144, 55));
        regionList.add(new CreateRegion("button_down", 864, 0, 144, 55));
        regionList.add(new CreateRegion("draggable_up", 720, 55, 103, 55));
        regionList.add(new CreateRegion("draggable_down", 823, 55, 103, 55));
        regionList.add(new CreateRegion("toggle_off", 720, 110, 142, 144));
        regionList.add(new CreateRegion("toggle_on", 862, 110, 142, 144));
        
        TextureSystem.getInstance().add(new CreateTexture("texture_1", R.drawable.texture_1), regionList);
    }
    
    @Override
    protected Scene onBuildScene() {
        Scene scene = new Scene("scene", 720, 480, "texture_1", "background");
        
        {
            // button
            Entity entity = new Entity("button", 196, 120, 144, 55);
            RenderComponent up = new RenderComponent("texture_1", "button_up");
            RenderComponent down = new RenderComponent("texture_1", "button_down");
            entity.add(up);
            
            ButtonComponent button = new ButtonComponent("button", 196, 120, 340, 175);
            button.setPresentation(up, down);
            entity.add(button);
            
            scene.add(entity);
        }
        
        {
            // toggle button
            Entity entity = new Entity("toggle", 400, 240, 142, 144);
            RenderComponent up = new RenderComponent("texture_1", "toggle_off");
            RenderComponent down = new RenderComponent("texture_1", "toggle_on");
            entity.add(up);
            
            ToggleButton toggle = new ToggleButton("toggle-button", 400, 240, 542, 384);
            toggle.setPresentation(up, down);
            entity.add(toggle);
            
            scene.add(entity);
        }
        
        {
            // draggable
            Entity entity = new Entity("draggable", 200, 240, 103, 55);
            RenderComponent up = new RenderComponent("texture_1", "draggable_up");
            RenderComponent down = new RenderComponent("texture_1", "draggable_down");
            entity.add(up);
            
            DraggableComponent draggable = new DraggableComponent("draggable");
            draggable.setPresentation(up, down);
            entity.add(draggable);
            
            scene.add(entity);
        }
        
        return scene;
    }

}
