package com.studioirregular.tatala.check;

import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.ListView;

public class DemosList extends ListActivity {

	private static final String[] DEMO_NAMES = {
		"Entity",
		"Performance Profile",
		"Frame Animation",
		"Button & Draggable"
	};
	
	private static List<Class<? extends Activity> > DEMO_ACTIVITIES = new ArrayList<Class<? extends Activity> >();
	static {
		DEMO_ACTIVITIES.add(DemoEntity.class);
		DEMO_ACTIVITIES.add(DemoProfiling.class);
		DEMO_ACTIVITIES.add(DemoAnimation.class);
		DEMO_ACTIVITIES.add(DemoButton.class);
	}
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		this.setListAdapter(new ArrayAdapter<String>(this,
				android.R.layout.simple_list_item_1, DEMO_NAMES));
	}

	@Override
	protected void onListItemClick(ListView l, View v, int position, long id) {
		if (position < DEMO_ACTIVITIES.size()) {
			startActivity(new Intent(DemosList.this,
					DEMO_ACTIVITIES.get(position)));
		}
	}

}
