package com.studioirregular.tatala.component;

import com.studioirregular.tatala.GameObject;

/**
 * Base class for game components.
 * 
 * Subclass should call my {@link #update(long, GameObject)} if override it. 
 * 
 * @author Michael Wang
 *
 */
public abstract class GameComponent extends GameObject {

    public GameComponent() {
        this("unknown");
    }
    
    public GameComponent(String id) {
        super(id);
    }

    @Override
    public void update(int timeDelta, GameObject parent) {
        //Debug.d(this.getClass().getSimpleName() + " id:" + id + " >> update parent:" + (parent != null ? parent.id : "null"));
    }
    
}
