package com.studioirregular.tatala.component;

import com.studioirregular.tatala.entity.Entity;

public class MoveAnimation extends AnimationComponent {

    public MoveAnimation(int durationInMilliSeconds, boolean loop, float fromX, float toX,
            float fromY, float toY) {
        super(durationInMilliSeconds, loop);

        this.fromX = fromX;
        this.toX = toX;
        this.fromY = fromY;
        this.toY = toY;
    }
    
    @Override
    protected void doUpdate(int animTime, Entity parent) {
        final float newX = fromX + (toX - fromX) * animTime / this.duration;
        final float newY = fromY + (toY - fromY) * animTime / this.duration;
        
        parent.box.offsetTo(newX, newY);
    }
    
    protected float fromX, toX;
    protected float fromY, toY;

}
