package com.studioirregular.tatala.component;

import com.studioirregular.tatala.entity.Entity;

public class RotateAnimation extends AnimationComponent {

    public RotateAnimation(int durationInMilliSeconds, boolean loop, float fromAngle, float toAngle) {
        super(durationInMilliSeconds, loop);
        
        this.fromAngle = fromAngle;
        this.toAngle = toAngle;
    }

    @Override
    protected void doUpdate(int animTime, Entity parent) {
        final float newAngle = this.fromAngle + (this.toAngle - this.fromAngle) * animTime / duration;
        parent.rotation = newAngle;
    }
    
    protected float fromAngle, toAngle;

}
