package com.studioirregular.tatala.component;

import com.studioirregular.tatala.entity.Entity;

public class ScaleAnimation extends AnimationComponent {

    public ScaleAnimation(int durationInMilliSeconds, boolean loop, float fromScaleX,
            float toScaleX, float fromScaleY, float toScaleY) {
        super(durationInMilliSeconds, loop);

        this.fromScaleX = fromScaleX;
        this.toScaleX = toScaleX;
        this.fromScaleY = fromScaleY;
        this.toScaleY = toScaleY;
    }
    
    @Override
    protected void doUpdate(int animTime, Entity parent) {
        final float newScaleX = fromScaleX + (toScaleX - fromScaleX) * animTime / duration;
        final float newScaleY = fromScaleY + (toScaleY - fromScaleY) * animTime / duration;
        
        parent.scaleX = newScaleX;
        parent.scaleY = newScaleY;
    }
    
    protected float fromScaleX, toScaleX;
    protected float fromScaleY, toScaleY;

}
