package com.studioirregular.tatala.component;

import com.studioirregular.tatala.entity.Entity;

public class ToggleButton extends ButtonComponent {

    public ToggleButton(String id, float left, float top, float right, float bottom) {
        super(id, left, top, right, bottom);
        toggleOn = false;
    }
    
    @Override
    protected void notifyStateChanged(Entity parent) {
        if (!toggleOn) {
            if (buttonDown) {
                parent.remove(up);
                parent.add(down);
            } else {
                toggleOn = true;
            }
        } else {
            if (buttonDown) {
                ; // do nothing
            } else {
                parent.remove(down);
                parent.add(up);
                toggleOn = false;
            }
        }
    }
    
    private boolean toggleOn;

}
