package com.studioirregular.tatala.entity;

import com.studioirregular.tatala.component.RenderComponent;
import com.studioirregular.tatala.util.Color;

/**
 * Game tree root.
 * 
 * Supports background.
 * 
 * @author Michael Wang
 *
 */
public class Scene extends Entity {

    public Scene(float width, float height, Color bgColor) {
        this("unkown", width, height, bgColor);
    }
    
	public Scene(String id, float width, float height, Color bgColor) {
		super(id, 0, 0, width, height);
		
		if (bgColor != null) {
	        bg = new RenderComponent(bgColor);
	        this.add(bg);
		}
	}
	
	public Scene(String id, float width, float height, String bgTextureName, String bgRegionName) {
	    super(id, 0, 0, width, height);
	    
	    bg = new RenderComponent(bgTextureName, bgRegionName);
	    this.add(bg);
	}
	
	public void setBackground(Color color) {
	    bg.setColor(color);
	}
	
	protected RenderComponent bg;

}
