package com.studioirregular.tatala.graphics;

import javax.microedition.khronos.opengles.GL10;

import com.studioirregular.tatala.graphics.RenderSystem.Drawable;
import com.studioirregular.tatala.util.Color;

public class ColorDrawable extends Drawable {

    public ColorDrawable(float width, float height, Color color) {
        super(width, height);
        this.color = new Color(color);
    }

    @Override
    public void draw(GL10 gl) {
        gl.glEnableClientState(GL10.GL_VERTEX_ARRAY);
        gl.glVertexPointer(3, GL10.GL_FLOAT, 0, vertex);
        
        gl.glColor4f(color.red(), color.green(), color.blue(), color.alpha());
        gl.glDrawArrays(GL10.GL_TRIANGLE_STRIP, 0, 4);
        gl.glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
        
        gl.glDisableClientState(GL10.GL_VERTEX_ARRAY);
    }
    
    private Color color;

}
