package com.studioirregular.tatala.util;

/**
 * Wrapper for 4 float color values: red, green blue, alpja.
 * Each value is of range: [0.0f, 1.0f]
 * 
 * @author Michael Wang
 *
 */
public class Color {

	public Color(float r, float g, float b, float a) {
		this.red = r;
		this.green = g;
		this.blue = b;
		this.alpha = a;
	}
	
	public Color(Color rhs) {
		if (rhs != null) {
			this.red = rhs.red;
			this.green = rhs.green;
			this.blue = rhs.blue;
			this.alpha = rhs.alpha;
		}
	}
	
	public void set(Color rhs) {
		if (rhs != null) {
			this.red = rhs.red;
			this.green = rhs.green;
			this.blue = rhs.blue;
			this.alpha = rhs.alpha;
		}
	}
	
	public float red() {
		return red;
	}
	
	public void setRed(float r) {
		this.red = r;
	}
	
	public float green() {
		return green;
	}
	
	public void setGreen(float g) {
		this.green = g;
	}
	
	public float blue() {
		return blue;
	}
	
	public void setBlue(float b) {
		this.blue = b;
	}
	
	public float alpha() {
		return alpha;
	}
	
	public void setAlpha(float a) {
		this.alpha = a;
	}
	
	@Override
	public String toString() {
		return "Color r:" + red + ",g:" + green + ",b:" + blue + ",a:" + alpha;
	}
	
	private float red = 0.0f;
	private float green = 0.0f;
	private float blue = 0.0f;
	private float alpha = 0.0f;
}
